# Tutorials

In order to use the full potential of the `Rostok` library a user needs to get accustomed with features of the framework.  
We prepared tutorials that show what one can do with the library.

1. [Create node and rule vocabularies](tutorial_rules_and_nodes_vocabulary.html)
2. [Create graphs using nodes and rules](tutorial_graph.html)
3. [Set the object to grasp and use the built graphs to start simulation of the grasping mechanism](tutorial_sym_step.html)
4. [Use optimizer to get optimal joint trajectories and best reward for the mechanism](tutorial_control_optimization.html)
5. [Use node and rule vocabularies to search the design of grasping robot for a simple body](tutorial_control_optimization.html)

# Documentation

For the most important parts of the framework we provide code documentation

### Classes:

[NodeVocabulary](./api/node_vocabulary.html)
[RuleVocabulary](./api/rule_vocabulary.html)

### Modules:
[node](./api/node.html)
[node_render](./api/node_render.html)
[criterion_calculation](./api/criterion_calc.html)
[flag_simulations](./api/flag_simulations.html)